<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/iron-form/iron-form.html">
<link rel="import" href="../bower_components/vaadin-button/vaadin-button.html">
<link rel="import" href="../bower_components/vaadin-dialog/vaadin-dialog.html">
<link rel="import" href="../bower_components/vaadin-checkbox/vaadin-checkbox.html">
<link rel="import" href="../bower_components/vaadin-form-layout/vaadin-form-layout.html">
<link rel="import" href="../bower_components/vaadin-form-layout/vaadin-form-item.html">
<link rel="import" href="../bower_components/vaadin-text-field/vaadin-text-area.html">
<link rel="import" href="../bower_components/vaadin-radio-button/vaadin-radio-group.html">
<link rel="import" href="../bower_components/vaadin-radio-button/vaadin-radio-button.html">
<link rel="import" href="../bower_components/vaadin-list-box/vaadin-list-box.html">
<link rel="import" href="../bower_components/vaadin-date-picker/vaadin-date-picker.html">
<link rel="import" href="../bower_components/vaadin-dropdown-menu/vaadin-dropdown-menu.html">
<link rel="import" href="../bower_components/vaadin-combo-box/vaadin-combo-box.html">
<link rel="import" href="../bower_components/vaadin-upload/vaadin-upload.html">
<link rel="import" href="../bower_components/vaadin-ordered-layout/vaadin-vertical-layout.html">
<link rel="import" href="../bower_components/vaadin-ordered-layout/vaadin-horizontal-layout.html">
<link rel="import" href="../bower_components/vaadin-notification/vaadin-notification.html">
<link rel="import" href="../bower_components/vaadin-text-field/vaadin-text-field.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid-filter.html">
<link rel="import" href="../bower_components/brum-global-variable/brum-global-variable.html">
<link rel="import" href="shared-styles.html">

<dom-module id="submit-new">
  <template>
    <style include="shared-styles">
      :host {
        display: block;
        background: transparent;
      }
      small.commands {
        white-space: nowrap;
      }
    </style>

    <brum-global-variable key="apiBase" value="{{apiBase}}" readonly></brum-global-variable>
    <brum-global-variable key="backendBase" value="{{backendBase}}" readonly></brum-global-variable>
    <iron-ajax auto with-credentials url="[[apiBase]]/programming-languages"
               last-response="{{_programmingLanguagesResult}}"></iron-ajax>

    <div class="card">
      <iron-form with-credentials id="form" on-iron-form-response="_handleFormResponse">
        <form method="post" action="[[apiBase]]/submit">
          <vaadin-vertical-layout>
            <h2>Submit and compile code</h2>
            <vaadin-form-layout>

              <vaadin-form-item>
                <label slot="label">Source archive</label>
                <vaadin-upload class="full-width" max-files="1" target="[[apiBase]]/upload" with-credentials
                               accept=".tar,.tar.gz,.tgz,.tar.bz2,.tar.xz" files="{{archiveFiles}}"
                               on-upload-success="_handleArchiveUploadSuccess" id="archiveUpload"></vaadin-upload>
                <input type="hidden" name="archive" value$="[[_extractResult(archiveFiles.0.xhr.response)]]">
              </vaadin-form-item>

              <vaadin-form-item>
                <label slot="label">Language</label>
                <vaadin-combo-box class="full-width" items="[[_programmingLanguagesResult.result]]"
                                  item-label-path="_id" name="programmingLanguage"
                                  selected-item="{{programmingLanguage}}">
                  <template>
                    <b>[[item._id]]</b><br>
                    <small class="commands">
                      build: <code>[[item.build]]</code><br>
                      run: <code>[[item.run]]</code>
                    </small>
                  </template>
                </vaadin-combo-box>
              </vaadin-form-item>

              <vaadin-form-item>
                <label slot="label">Build command</label>
                <vaadin-text-field name="buildCmd" required class="full-width" readonly
                                   placeholder="make all" value="[[programmingLanguage.build]]"></vaadin-text-field>
              </vaadin-form-item>

              <vaadin-form-item>
                <label slot="label">Run command</label>
                <vaadin-text-field name="runCmd" required class="full-width" readonly
                                   placeholder="make run" value="[[programmingLanguage.run]]"></vaadin-text-field>
              </vaadin-form-item>

              <vaadin-form-item colspan="2">
                <vaadin-button on-click="_submitForm">Submit</vaadin-button>
              </vaadin-form-item>

            </vaadin-form-layout>
          </vaadin-vertical-layout>
        </form>
      </iron-form>
    </div>

    <div class="card">
      <h2>Submitted</h2>
      <vaadin-grid items="[[submissions]]">

        <vaadin-grid-column>
          <template class="header">Date</template>
          <template>[[item.date]]</template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">Status</template>
          <template>[[item.status]]</template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">ID</template>
          <template>
            <a>[[_formatImageId(item.imageId)]]</a>
          </template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">Build</template>
          <template>
            <a href="[[backendBase]]/containers/[[item.containerId]]/logs">Logs</a>
          </template>
        </vaadin-grid-column>

      </vaadin-grid>
    </div>

    <vaadin-notification id="errorNotification" opened="{{formInvalidOpen}}" duration="4000">
      <template>
        <h3>Error while submitting</h3>
        <span>[[lastError.message]]</span>
      </template>
    </vaadin-notification>
  </template>

  <script>
    class SubmitNew extends Polymer.Element {
      static get is() {
        return 'submit-new';
      }

      // noinspection JSUnusedGlobalSymbols
      static get properties() {
        return {
          submissions: {
            type: Array,
            value: [],
            notify: true,
            readOnly: true,
          },
          lastError: {
            type: Object,
            notify: true,
            readOnly: true,
          },
        };
      }

      // noinspection JSUnusedGlobalSymbols
      toggleDialog(e) {
        e.stopPropagation();
        e.preventDefault();
        this.dialogOpen = !this.dialogOpen;
      }

      // noinspection JSUnusedGlobalSymbols
      _submitForm() {
        if (this.$.form.validate()) {
          this.$.form.submit();
        }
      }

      // noinspection JSMethodCanBeStatic
      // noinspection JSUnusedGlobalSymbols
      _extractResult(response) {
        if (response === undefined) {
          return undefined;
        }

        if (typeof response === 'string') {
          response = JSON.parse(response);
        }
        return response.result;
      }

      // noinspection JSUnusedGlobalSymbols
      _handleArchiveUploadSuccess() {
        // noinspection JSUnresolvedVariable
        this.$.archiveUpload.notifyPath('files.0.xhr.response');
      }

      // noinspection JSUnusedGlobalSymbols
      _handleFormResponse(event) {
        if (event.detail.response.type === 'error') {
          // noinspection JSUnusedGlobalSymbols
          this.lastError = event.detail.response;
          // noinspection JSUnresolvedVariable
          this.$.errorNotification.opened = true;
        } else {
          this.unshift('submissions', event.detail.response);
        }
      }

      // noinspection JSMethodCanBeStatic
      // noinspection JSUnusedGlobalSymbols
      _formatImageId(imageId) {
        try {
          return imageId.match(/^(?:[a-z0-9]+:)?([a-z0-9]{12})/)[1];
        } catch (e) {
          return imageId;
        }
      }
    }

    window.customElements.define(SubmitNew.is, SubmitNew);
  </script>
</dom-module>
